---
title: CanvasRenderingContext2D.clearRect()
slug: Web/API/CanvasRenderingContext2D/clearRect
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.clearRect()</code></strong> method of the Canvas 2D API erases the pixels in a rectangular area by setting them to transparent black.</p>

<div class="notecard note">
<p><strong>Note:</strong> Be aware that <code>clearRect()</code> may cause unintended side effects if you're not <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Drawing_shapes#Drawing_paths">using paths properly</a>. Make sure to call {{domxref("CanvasRenderingContext2D.beginPath", "beginPath()")}} before starting to draw new items after calling <code>clearRect()</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.clearRect(<em>x</em>, <em>y</em>, <em>width</em>, <em>height</em>);
</pre>

<p>The <code>clearRect()</code> method sets the pixels in a rectangular area to transparent black (<code>rgba(0,0,0,0)</code>). The rectangle's corner is at <code>(x, y)</code>, and its size is specified by <code>width</code> and <code>height</code>.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the rectangle's starting point.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the rectangle's starting point.</dd>
 <dt><code>width</code></dt>
 <dd>The rectangle's width. Positive values are to the right, and negative to the left.</dd>
 <dt><code>height</code></dt>
 <dd>The rectangle's height. Positive values are down, and negative are up.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Erasing_the_whole_canvas">Erasing the whole canvas</h3>

<p>This code snippet erases the entire canvas. This is commonly required at the start of each frame in an animation. The dimensions of the cleared area are set to equal the {{HtmlElement("canvas")}} element's <code>width</code> and <code>height</code> attributes.</p>

<pre class="brush: js; highlight:[3]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.clearRect(0, 0, canvas.width, canvas.height);</pre>

<h3 id="Erasing_part_of_a_canvas">Erasing part of a canvas</h3>

<p>This example draws a blue triangle on top of a yellowish background. The <code>clearRect()</code> method then erases part of the canvas.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The cleared area is rectangular in shape, with its top-left corner at (10, 10). The cleared area has a width of 120 and a height of 100.</p>

<pre class="brush: js; highlight:[19]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Draw yellow background
ctx.beginPath();
ctx.fillStyle = '#ff6';
ctx.fillRect(0, 0, canvas.width, canvas.height);

// Draw blue triangle
ctx.beginPath();
ctx.fillStyle = 'blue';
ctx.moveTo(20, 20);
ctx.lineTo(180, 20);
ctx.lineTo(130, 130);
ctx.closePath();
ctx.fill();

// Clear part of the canvas
ctx.clearRect(10, 10, 120, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Erasing_part_of_a_canvas', 700, 180)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-clearrect", "CanvasRenderingContext2D.clearRect")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.clearRect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.fillRect()")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.strokeRect()")}}</li>
</ul>
